#
# TODO:
# - IMPORTANT rename: http://www.asterisk.org/zaptel-to-dahdi
# - Fix --without xpp:
#   + check_modules
#   unpackaged module: drivers/dahdi/xpp/xpd_bri
#   unpackaged module: drivers/dahdi/xpp/xpd_fxo
#   unpackaged module: drivers/dahdi/xpp/xpd_fxs
#   unpackaged module: drivers/dahdi/xpp/xpd_pri
#   unpackaged module: drivers/dahdi/xpp/xpp
#   unpackaged module: drivers/dahdi/xpp/xpp_usb
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without  kernel		# don't build kernel modules
%bcond_with	oslec		# with Open Source Line Echo Canceller
%bcond_without	xpp		# without Astribank
%bcond_without	userspace	# don't build userspace packages
%bcond_with	verbose

%ifarch alpha
%undefine	with_xpp
%endif

%if %{without kernel}
%undefine	with_dist_kernel
%endif

# The goal here is to have main, userspace, package built once with
# simple release number, and only rebuild kernel packages with kernel
# version as part of release number, without the need to bump release
# with every kernel change.
%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if "%{_alt_kernel}" != "%{nil}"
%if 0%{?build_kernels:1}
%{error:alt_kernel and build_kernels are mutually exclusive}
exit 1
%endif
%undefine	with_userspace
%global		_build_kernels		%{alt_kernel}
%else
%global		_build_kernels		%{?build_kernels:,%{?build_kernels}}
%endif

%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		kbrs	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo "BuildRequires:kernel%%{_alt_kernel}-module-build >= 3:2.6.20.2" ; done)
%define		kpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%kernel_pkg ; done)
%define		bkpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%build_kernel_pkg ; done)

%define		rel	12
%define		pname	dahdi-linux
%define		FIRMWARE_URL http://downloads.digium.com/pub/telephony/firmware/releases
Summary:	DAHDI telephony device support
Summary(pl.UTF-8):	Obsługa urządzeń telefonicznych DAHDI
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	2.7.0.1
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	GPL v2
Group:		Base/Kernel
Source0:	http://downloads.asterisk.org/pub/telephony/dahdi-linux/releases/dahdi-linux-%{version}.tar.gz
# Source0-md5:	bd91e46c60b6cdcdee95d7b0fec45e32
Source3:	%{FIRMWARE_URL}/dahdi-fw-oct6114-064-1.05.01.tar.gz
# Source3-md5:	88db9b7a07d8392736171b1b3e6bcc66
Source4:	%{FIRMWARE_URL}/dahdi-fw-oct6114-128-1.05.01.tar.gz
# Source4-md5:	c1f1a18d3e20d283f42c71e580a64b5a
Source5:	%{FIRMWARE_URL}/dahdi-fw-vpmadt032-1.07.tar.gz
# Source5-md5:	e1c7231d6225ac999cb18f4e858f66b6
Source6:	%{FIRMWARE_URL}/dahdi-fw-tc400m-MR6.12.tar.gz
# Source6-md5:	2ea860bb8a9d8ede2858b9557b74ee3c
Source7:	%{FIRMWARE_URL}/dahdi-fw-hx8-2.06.tar.gz
# Source7-md5:	a7f3886942bb3e9fed349a41b3390c9f
URL:		http://www.asterisk.org/
BuildRequires:	rpmbuild(macros) >= 1.678
%{?with_dist_kernel:%{expand:%kbrs}}
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.379
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# Rules:
# - modules_X: single modules, just name module with no suffix
# - modules_X: subdir modules are just directory name with slash like dirname/
# - keep X and X_in in sync
# - X is used for actual building (entries separated with space), X_in for pld macros (entries separated with comma)

%define	modules_1	dahdi.o dahdi_dynamic.o dahdi_dynamic_eth.o dahdi_dynamic_ethmf.o dahdi_dynamic_loc.o dahdi_echocan_jpah.o dahdi_echocan_kb1.o dahdi_echocan_mg2.o dahdi_echocan_sec.o dahdi_echocan_sec2.o pciradio.o tor2.o wcfxo.o wct1xxp.o wctdm.o wcte11xp.o
%define	modules_1_in	dahdi,dahdi_dynamic,dahdi_dynamic_eth,dahdi_dynamic_ethmf,dahdi_dynamic_loc,dahdi_echocan_jpah,dahdi_echocan_kb1,dahdi_echocan_mg2,dahdi_echocan_sec,dahdi_echocan_sec2,pciradio,tor2,wcfxo,wct1xxp,wctdm,wcte11xp
%define	modules_2	voicebus/ wct4xxp/ wcte12xp/ %{?with_xpp:xpp/}
%define	modules_2_in	voicebus/dahdi_voicebus,wct4xxp/wct4xxp,wcte12xp/wcte12xp,%{?with_xpp:xpp/xpd_bri,xpp/xpd_echo,xpp/xpd_fxo,xpp/xpd_fxs,xpp/xpd_pri,xpp/xpp,xpp/xpp_usb}
%ifnarch alpha
%define	modules_nalpha	wctc4xxp/ wctdm24xxp/ dahdi_transcode.o wcb4xxp/
%define	modules_nalpha_in	wctc4xxp/wctc4xxp,wctdm24xxp/wctdm24xxp,dahdi_transcode,wcb4xxp/wcb4xxp
%endif
%define	modules		%{modules_1} %{modules_2}%{?modules_nalpha: %{modules_nalpha}}
%define	modules_in	%{modules_1_in},%{modules_2_in}%{?modules_nalpha:,%{modules_nalpha_in}}

%description
DAHDI telephony device driver.

%description -l pl.UTF-8
Sterownik do urządzeń telefonicznych DAHDI.

%package devel
Summary:	Header files for dahdi interface
Summary(pl.UTF-8):	Pliki nagłówkowe interfejsu dahdi
Group:		Development/Libraries

%description devel
Header files for dahdi interface.

%description devel -l pl.UTF-8
Pliki nagłówkowe interfejsu dahdi.

%package udev
Summary:	udev rules for DAHDI kernel modules
Summary(pl.UTF-8):	Reguły udev dla modułów jądra Linuksa dla DAHDI
Release:	%{rel}
Group:		Base/Kernel
Requires:	dahdi-tools >= 2.2.0
Requires:	udev-core

%description udev
udev rules for DAHDI kernel modules.

%description udev -l pl.UTF-8
Reguły udev dla modułów jądra Linuksa dla DAHDI.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-%{pname}\
Summary:	DAHDI Linux kernel driver\
Summary(pl.UTF-8):	Sterownik DAHDI dla jądra Linuksa\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%if %{with dist_kernel}\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
%{?with_oslec:Requires:	kernel-misc-oslec = 20070608-0.1@%{_kernel_ver_str}}\
%endif\
\
%description -n kernel%{_alt_kernel}-%{pname}\
DAHDI telephony Linux kernel driver.\
\
%description -n kernel%{_alt_kernel}-%{pname} -l pl.UTF-8\
Sterownik dla jądra Linuksa do urządzeń telefonicznych DAHDI.\
\
%if %{with kernel}\
%files -n kernel%{_alt_kernel}-%{pname}\
%defattr(644,root,root,755)\
/lib/modules/%{_kernel_ver}/misc/dahdi*.ko*\
/lib/modules/%{_kernel_ver}/misc/pciradio.ko*\
/lib/modules/%{_kernel_ver}/misc/tor2.ko*\
/lib/modules/%{_kernel_ver}/misc/wcb4xxp.ko*\
/lib/modules/%{_kernel_ver}/misc/wcfxo.ko*\
/lib/modules/%{_kernel_ver}/misc/wct1xxp.ko*\
/lib/modules/%{_kernel_ver}/misc/wct4xxp.ko*\
/lib/modules/%{_kernel_ver}/misc/wctc4xxp.ko*\
/lib/modules/%{_kernel_ver}/misc/wctdm.ko*\
/lib/modules/%{_kernel_ver}/misc/wctdm24xxp.ko*\
/lib/modules/%{_kernel_ver}/misc/wcte11xp.ko*\
/lib/modules/%{_kernel_ver}/misc/wcte12xp.ko*\
%if %{with xpp}\
/lib/modules/%{_kernel_ver}/misc/xpd_*.ko*\
/lib/modules/%{_kernel_ver}/misc/xpp.ko*\
/lib/modules/%{_kernel_ver}/misc/xpp_usb.ko*\
%endif\
%endif\
\
%post -n kernel%{_alt_kernel}-%{pname}\
%depmod %{_kernel_ver}\
\
%postun -n kernel%{_alt_kernel}-%{pname}\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%if %{with kernel}\
# hack: build library first (using explicit "lib" target), then modules without cleaning (-c)\
%build_kernel_modules lib SUBDIRS=$PWD/drivers/dahdi DAHDI_BUILD_ALL=m HOTPLUG_FIRMWARE=yes DAHDI_MODULES_EXTRA=" " -m %{modules_in} KSRC=$PWD/o -C drivers/dahdi/oct612x DAHDI_INCLUDE=$PWD/../../include\
%build_kernel_modules SUBDIRS=$PWD/drivers/dahdi DAHDI_BUILD_ALL=m HOTPLUG_FIRMWARE=yes DAHDI_MODULES_EXTRA=" " -m %{modules_in} KSRC=$PWD/o -C drivers/dahdi DAHDI_INCLUDE=$PWD/../../include -c\
cd drivers/dahdi\
%install_kernel_modules -D ../../installed -m %{modules_in} -d misc\
cd ../..\
%endif\
%{nil}

%{?with_kernel:%{expand:%kpkg}}

%prep
%setup -q -n %{pname}-%{version}

for a in %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7}; do
	ln -s $a drivers/dahdi/firmware
	tar -C drivers/dahdi/firmware -xzf $a
done

cat > download-logger <<'EOF'
#!/bin/sh
# keep log of files make wanted to download in firmware/ dir
echo "$@" >> download.log
EOF
chmod a+rx download-logger

%build
%{__make} include/dahdi/version.h

%{?with_kernel:%{expand:%bkpkg}}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_includedir}/dahdi

%if %{with userspace}
install -d $RPM_BUILD_ROOT/etc/udev/rules.d

%{__make} install-devices install-include \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{with kernel}
cp -a installed/* $RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
%files devel
%defattr(644,root,root,755)
%{_includedir}/dahdi

%files udev
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/udev/rules.d/dahdi.rules
%config(noreplace) %verify(not md5 mtime size) /etc/udev/rules.d/xpp.rules
%endif
%changelog
* Fri Dec 27 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dahdi-linux.git;a=log;h=auto/th/dahdi-linux-2.7.0.1-12

* Mon Oct 28 2013 Jan Rękorajski <baggins@pld-linux.org> 1a93d7c
- add -kernel suffix to (srpm) package name when building kernel modules on builders
- autogenerate kernel BRs
- rel 12

* Sun Oct 27 2013 Jan Rękorajski <baggins@pld-linux.org> 228a18e
- switch to macro driven module build for multiple kernel versions
- rel 11

* Mon Oct 07 2013 Jan Rękorajski <baggins@pld-linux.org> ba3fac1
- rebuild for kernel-3.10.15-1
- release 10 (by relup.sh)

* Wed Oct 02 2013 Jan Rękorajski <baggins@pld-linux.org> a879206
- rebuild for kernel-3.10.14-1
- release 9 (by relup.sh)

* Fri Sep 27 2013 Jan Rękorajski <baggins@pld-linux.org> d52204b
- rebuild for kernel-3.10.13-1
- release 8 (by relup.sh)

* Sun Sep 15 2013 Jan Rękorajski <baggins@pld-linux.org> b7676ba
- rebuild for kernel-3.10.12-1
- release 7 (by relup.sh)

* Tue Sep 10 2013 Jan Rękorajski <baggins@pld-linux.org> fa223bf
- rebuild for kernel-3.10.11-1
- release 6 (by relup.sh)

* Fri Aug 30 2013 Jakub Bogusz <qboosh@pld-linux.org> 2c402d2
- updated to 2.7.0.1
- removed obsolete build patch

* Thu Aug 29 2013 Jan Rękorajski <baggins@pld-linux.org> 7d63cba
- rebuild for kernel-3.10.10-1
- release 5 (by relup.sh)

* Sat Aug 24 2013 Jan Rękorajski <baggins@pld-linux.org> b39971a
- rebuild for kernel-3.10.9-1
- release 4 (by relup.sh)

* Thu Aug 15 2013 Jan Rękorajski <baggins@pld-linux.org> bb15d14
- release 3 (by relup.sh)

* Thu Jul 25 2013 Jan Rękorajski <baggins@pld-linux.org> ba9a6cd
- rebuild for kernel-3.9.11-1
- release 2 (by relup.sh)

* Sun Jul 21 2013 Jakub Bogusz <qboosh@pld-linux.org> c792012
- updated to 2.7.0

* Wed Jul 03 2013 Jan Rękorajski <baggins@pld-linux.org> 2c59ca3
- rebuild for kernel-3.9.9-1
- release 23 (by relup.sh)

* Thu Jun 27 2013 Jan Rękorajski <baggins@pld-linux.org> 0753767
- rebuild for kernel-3.9.8-1
- release 22 (by relup.sh)

* Thu Jun 20 2013 Jan Rękorajski <baggins@pld-linux.org> eaad488
- rebuild for kernel-3.9.7-1
- release 21 (by relup.sh)

* Thu Jun 13 2013 Jan Rękorajski <baggins@pld-linux.org> f9e8366
- rebuild for kernel-3.9.6-1
- release 20 (by relup.sh)

* Fri Jun 07 2013 Jan Rękorajski <baggins@pld-linux.org> d730ef9
- rebuild for kernel-3.9.5-1 /home/users/baggins/devel/PLD/rpm/packages
- release 19 (by relup.sh)

* Mon Jun 03 2013 Jan Rękorajski <baggins@pld-linux.org> bbefb1d
- rebuild for kernel-3.9.4-3
- release 18 (by relup.sh)

* Fri May 24 2013 Jan Rękorajski <baggins@pld-linux.org> 1fcb42f
- rebuild for kernel-3.7.10-9
- release 17 (by relup.sh)

